/*****************************************************************
JADE - Java Agent DEvelopment Framework is a framework to develop
multi-agent systems in compliance with the FIPA specifications.
Copyright (C) 2000 CSELT S.p.A. 

GNU Lesser General Public License

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, 
version 2.1 of the License. 

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.
*****************************************************************/

package jade.domain.introspection;

import jade.content.Predicate;

/**

  This class represents the <code>occurred</code> predicate, whose
  argument is a JADE introspection event.

  @author Giovanni Rimassa - Universita' di Parma
  @version $Date: 2003/11/19 16:04:36 $ $Revision: 1.5 $
*/
public class Occurred implements Predicate {

    private EventRecord arg;

    /**
       Default constructor. A default constructor is necessary for
       ontological classes.
    */
    public Occurred() {
    }

    /**
       Set the <code>what</code> slot of this event.
       @param er The record of the occurred event, along with location
       and timestamp information.
    */
    public void setWhat(EventRecord er) {
	arg = er;
    }

    /**
       Retrieve the value of the <code>what</code> slot of this event,
       containing the record of the occurred event, along with
       location and timestamp information.
       @return The value of the <code>what</code> slot, or
       <code>null</code> if no value was set.
    */
    public EventRecord getWhat() {
	return arg;
    }


}
